/*
XASTIR, Amateur Station Tracking and Information Reporting
Copyright (C) 1999  Frank Giannandrea

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

More information on the program can be found at:
Web,
 http://www.eazy.net/users/fgiannan/xasitr/
Email,
 fgiannan@eazy.net
*/

#include <stdlib.h>
#include <stdio.h>

#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/PanedW.h>
#include <Xm/Protocols.h>
#include <Xm/PushBG.h>
#include <Xm/ScrollBar.h>
#include <Xm/SeparatoG.h>
#include <Xm/TextF.h>

#include "main.h"
#include "xastir.h"

extern char *get_time(char *time_here);
extern time_t sec_now(void);

extern Widget GetTopShell(Widget w);
extern void pos_dialog(Widget w);
extern int units_english_metric;


/* from lang.c */
extern char *langcode(char *code);
extern char langcode_hotkey(char *code);

extern int stations;  
extern Widget appshell;
extern void symbol(Widget w, int ghost,char symbol_table, char symbol_id, char symbol_overlay, Pixmap where, int mask, long x_offset, long y_offset);
extern char *convert_long_lat_string(long lat, char *str);
extern char *convert_long_long_string(long lon, char *str);
extern double distance_between_string(char *lat_point1, char *long_point1, char *lat_point2, char *long_point2, char *course_deg);
/************ Station List ****************/
Widget station_list_dialog[4];
Widget SL_list[4][20];
Widget SL_da[4][20];
Widget SL_call[4][20];
Pixmap SL_icon[4][20];
Pixmap blank_icon;
Widget SL_scroll[4];
Widget SL_wx_wind_course[4][20];
Widget SL_wx_wind_speed[4][20];
Widget SL_wx_wind_gust[4][20];
Widget SL_wx_temp[4][20];
Widget SL_wx_hum[4][20];
Widget SL_wx_baro[4][20];
Widget SL_wx_rain_h[4][20];
Widget SL_wx_rain_00[4][20];
Widget SL_wx_rain_24[4][20];
Widget SL_course[4][20];
Widget SL_speed[4][20];
Widget SL_alt[4][20];
Widget SL_lat[4][20];
Widget SL_long[4][20];
Widget SL_packets[4][20];
Widget SL_sats[4][20];
Widget SL_my_course[4][20];
Widget SL_my_distance[4][20];
Widget SL_pos_time[4][20];
Widget SL_node_path[4][20];
Widget SL_power_gain[4][20];
Widget SL_comments[4][20];
int station_list_first=1;
int list_size_h[4];
int list_size_w[4];
int units_last;
int max_update;

void station_list_icons(void)
{int t,i;

 blank_icon = XCreatePixmap(XtDisplay(appshell),RootWindowOfScreen(XtScreen(appshell)),20,20,DefaultDepthOfScreen(XtScreen(appshell)));
 for (t=0;t<4;t++) {
     station_list_dialog[t]=NULL; 
     for (i=0;i<20;i++) {
         SL_icon[t][i] = XCreatePixmap(XtDisplay(appshell),RootWindowOfScreen(XtScreen(appshell)),20,20,DefaultDepthOfScreen(XtScreen(appshell)));
     }
 }
}

int stations_types(int type)
{int st;
 int i;
 int data_ptr_i;

 st=0;
 for (i=0;i<stations;i++) {
  data_ptr_i=station_ptr[i];   
  
  if (station_data[data_ptr_i].active == RECORD_ACTIVE ) {
     switch (type) {
       case 0:/*stations list */
              st++;
              break;

       case 1:/* mobile stations list */
              if (station_data[data_ptr_i].moving) 
                 st++;
               break;

       case 2:/*WX stations list */
              if (station_data[data_ptr_i].wx_data) 
                 st++;
               break;

       case 3:/* local stations list */
              if (station_data[data_ptr_i].heard_via_tnc==VIA_TNC) 
                 st++;
               break;

        default:break;
     }
  }
 }
if (st==0)
   st=1;

return(st);
}


void station_list_destroy_shell(Widget widget, XtPointer clientData, XtPointer callData)
{int i;

 i=atoi((char *)clientData);
 XtPopdown(station_list_dialog[i]);
 XtDestroyWidget(station_list_dialog[i]);
 station_list_dialog[i]= (Widget)NULL;
}


void Station_List_fill(int type, int offset)
{int i;
 int data_ptr_i;
 int x;
 int station_i;
 char temp[8];
 int ok;
 int num;
 int w,h;
 int ww,wh;
 int new_h;
 int max_x;
 char temp_long[20];
 char temp_lat[20];
 char stemp[400];
 char stemp1[60];
 char temp_call[20];

 x=0;
 station_i=0;
 w=h=ww=wh=0;
 if (station_list_dialog[type]!=NULL) {
 XtVaGetValues(station_list_dialog[type], XmNwidth,  &ww, XmNheight, &wh, NULL);
 XtVaGetValues(SL_scroll[type], XmNwidth,  &w, XmNheight, &h, NULL);
 max_x=h/29;
 new_h=(max_x*29)+(wh-h);
 XtVaSetValues(station_list_dialog[type], XmNheight, new_h, NULL);
 XtVaSetValues(SL_scroll[type], XmNpageIncrement, max_x, NULL);
 list_size_h[type]=new_h;
 list_size_w[type]=ww;

 data_ptr_i=station_ptr[station_i]; 
 for (i=offset;i<offset+18;i++) {
  
     ok=0;
     num=0;
     for (station_i=0;station_i<stations && !ok;station_i++) {
         data_ptr_i=station_ptr[station_i];   
 
         if (station_data[data_ptr_i].active == RECORD_ACTIVE ){
            switch (type) {
                 case 0:/*stations list */
                        if (num==i) 
                             ok=1;
                          num++;
                        break;

                 case 1:/* mobile stations list */
                       if (station_data[data_ptr_i].moving) { 
                          if (num==i) 
                             ok=1;
                          num++;
		       }
                        
                       break;

                 case 2:/*WX stations list */
                        if (station_data[data_ptr_i].wx_data) { 
                           if (num==i) 
                             ok=1;
                          num++;
		       }
                       break;

                 case 3:/* local stations list */
                       if (station_data[data_ptr_i].heard_via_tnc==VIA_TNC) { 
                          if (num==i) 
                             ok=1;
                          num++;
		       }
                       break;

                 default:break;
	    }
	 }
     }

     if(ok) {
         XtVaSetValues(SL_da[type][x],
                      XmNlabelPixmap, blank_icon,
                      NULL);      

         XtManageChild(SL_da[type][x]);

         symbol(SL_da[type][x],0,station_data[data_ptr_i].aprs_symbol.aprs_type,
               station_data[data_ptr_i].aprs_symbol.aprs_symbol,
               station_data[data_ptr_i].aprs_symbol.special_overlay,SL_icon[type][x],0,0,0);

         XtVaSetValues(SL_da[type][x],
                      XmNlabelPixmap, SL_icon[type][x],
                      NULL);      

         XtManageChild(SL_da[type][x]);

        sprintf(temp,"%d",(i+1));
        XmTextFieldSetString(SL_list[type][x],temp);
        XtManageChild(SL_list[type][x]);

        /* check to see if string changed and over write */
        strcpy(temp_call,XmTextFieldGetString(SL_call[type][x]));
        if (strcmp(temp_call,station_data[data_ptr_i].call_sign)!=0) {
           XmTextFieldSetString(SL_call[type][x],station_data[data_ptr_i].call_sign);
           XtManageChild(SL_call[type][x]);
	}

        switch (type) {
          case 3:/*local stations list */
          case 0:/*stations list */

               sprintf(stemp,"%d",station_data[data_ptr_i].num_packets);
               XmTextFieldSetString(SL_packets[type][x],stemp); 
               XtManageChild(SL_packets[type][x]);  


               if (strlen(station_data[data_ptr_i].pos_time)>13) {
                  sprintf(stemp,"%c%c/%c%c/%c%c%c%c %c%c:%c%c",
                                 station_data[data_ptr_i].pos_time[0],
                                 station_data[data_ptr_i].pos_time[1],
                                 station_data[data_ptr_i].pos_time[2],
                                 station_data[data_ptr_i].pos_time[3],
                                 station_data[data_ptr_i].pos_time[4],
                                 station_data[data_ptr_i].pos_time[5],
                                 station_data[data_ptr_i].pos_time[6],
                                 station_data[data_ptr_i].pos_time[7],
                                 station_data[data_ptr_i].pos_time[8],
                                 station_data[data_ptr_i].pos_time[9],
                                 station_data[data_ptr_i].pos_time[10],
                                 station_data[data_ptr_i].pos_time[11]
                                 );

	       } else sprintf(stemp," ");
               XmTextFieldSetString(SL_pos_time[type][x],stemp);
               XtManageChild(SL_pos_time[type][x]);  

               sprintf(stemp,"%s",station_data[data_ptr_i].node_path);
               XmTextFieldSetString(SL_node_path[type][x],stemp);
               XtManageChild(SL_node_path[type][x]); 

               sprintf(stemp,"%s",station_data[data_ptr_i].power_gain);
               XmTextFieldSetString(SL_power_gain[type][x],stemp);
               XtManageChild(SL_power_gain[type][x]);  

               sprintf(stemp,"%s",station_data[data_ptr_i].comments);
               XmTextFieldSetString(SL_comments[type][x],stemp);
               XtManageChild(SL_comments[type][x]);  

              break;

          case 1:/* mobile stations list */
               if (strlen(station_data[data_ptr_i].course)>0){
                  XmTextFieldSetString(SL_course[type][x],station_data[data_ptr_i].course);
	       } else XmTextFieldSetString(SL_course[type][x],"");
               XtManageChild(SL_course[type][x]); 

               if (strlen(station_data[data_ptr_i].speed)>0) {
                  if (!units_english_metric) {
                     sprintf(stemp,"%.1f",atof(station_data[data_ptr_i].speed)*1.852);
		  } else sprintf(stemp,"%.1f",atof(station_data[data_ptr_i].speed)*1.1508);
                  XmTextFieldSetString(SL_speed[type][x],stemp);
	       } else XmTextFieldSetString(SL_speed[type][x],"");
	       XtManageChild(SL_speed[type][x]); 

               if (strlen(station_data[data_ptr_i].altitude)>0) {
                  if (!units_english_metric) {
                     sprintf(stemp,"%s",station_data[data_ptr_i].altitude);
		  } else sprintf(stemp,"%.1f",atof(station_data[data_ptr_i].altitude)*3.28084);
                  XmTextFieldSetString(SL_alt[type][x],stemp);
	       } else XmTextFieldSetString(SL_alt[type][x],"");
	       XtManageChild(SL_alt[type][x]); 

               convert_long_lat_string(station_data[data_ptr_i].lat_pos, stemp);
               XmTextFieldSetString(SL_lat[type][x],stemp);
	       XtManageChild(SL_lat[type][x]); 

               convert_long_long_string(station_data[data_ptr_i].long_pos, stemp);
               XmTextFieldSetString(SL_long[type][x],stemp);
	       XtManageChild(SL_long[type][x]); 

               sprintf(stemp,"%d",station_data[data_ptr_i].num_packets);
               XmTextFieldSetString(SL_packets[type][x],stemp);
               XtManageChild(SL_packets[type][x]);  

               if (strlen(station_data[data_ptr_i].sats_visible)>0){
                  sprintf(stemp,"%d",atoi(station_data[data_ptr_i].sats_visible));
                  XmTextFieldSetString(SL_sats[type][x],stemp);
	       } else XmTextFieldSetString(SL_sats[type][x],"");
               XtManageChild(SL_sats[type][x]); 

              sprintf(temp_long,"%s%c",station_data[data_ptr_i].long_pos_x,station_data[data_ptr_i].long_ew);
              sprintf(temp_lat,"%s%c",station_data[data_ptr_i].lat_pos_y,station_data[data_ptr_i].lat_ns);
              if (units_english_metric) {
                 sprintf(stemp1,"%0.1f",(distance_between_string(my_lat,my_long,temp_lat,temp_long,stemp)*1.15078));
	      } else sprintf(stemp1,"%0.1f",(distance_between_string(my_lat,my_long,temp_lat,temp_long,stemp)*1.852));
	      XmTextFieldSetString(SL_my_course[type][x],stemp);
              XtManageChild(SL_my_course[type][x]);
	      XmTextFieldSetString(SL_my_distance[type][x],stemp1);
              XtManageChild(SL_my_distance[type][x]);
 
              break;

          case 2:/*WX stations list */

               if (station_data[data_ptr_i].wx_course_on) {
                  XmTextFieldSetString(SL_wx_wind_course[type][x],station_data[data_ptr_i].wx_course);                  
	       } else XmTextFieldSetString(SL_wx_wind_course[type][x],"");
               XtManageChild(SL_wx_wind_course[type][x]);
  
               if (station_data[data_ptr_i].wx_speed_on) {
                  if (!units_english_metric) {  
                     sprintf(stemp,"%d",(int)(atof(station_data[data_ptr_i].wx_speed)*1.6094));
		  } else sprintf(stemp,"%d",(int)atoi(station_data[data_ptr_i].wx_speed));
                  XmTextFieldSetString(SL_wx_wind_speed[type][x],stemp);
	       } else XmTextFieldSetString(SL_wx_wind_speed[type][x],"");
               XtManageChild(SL_wx_wind_speed[type][x]);	            

               if (station_data[data_ptr_i].wx_gust_on) {
                  if (!units_english_metric) {  
                     sprintf(stemp,"%d",(int)(atof(station_data[data_ptr_i].wx_gust)*1.6094));
		  } else sprintf(stemp,"%d",atoi(station_data[data_ptr_i].wx_gust));
                  XmTextFieldSetString(SL_wx_wind_gust[type][x],stemp);
	       } else XmTextFieldSetString(SL_wx_wind_gust[type][x],"");
               XtManageChild(SL_wx_wind_gust[type][x]);


               if (station_data[data_ptr_i].wx_temp_on) {
                  if (!units_english_metric) {  
                     sprintf(stemp,"%d",(int)(((atof(station_data[data_ptr_i].wx_temp)-32)*5.0)/9.0));
		  } else sprintf(stemp,"%d",atoi(station_data[data_ptr_i].wx_temp));
                  XmTextFieldSetString(SL_wx_temp[type][x],stemp);
	       } else XmTextFieldSetString(SL_wx_temp[type][x],"");
               XtManageChild(SL_wx_temp[type][x]);

               if (station_data[data_ptr_i].wx_hum_on) {
                  XmTextFieldSetString(SL_wx_hum[type][x],station_data[data_ptr_i].wx_hum);
	       }else XmTextFieldSetString(SL_wx_hum[type][x],"");
               XtManageChild(SL_wx_hum[type][x]);


               if (station_data[data_ptr_i].wx_baro_on) {
                  XmTextFieldSetString(SL_wx_baro[type][x],station_data[data_ptr_i].wx_baro);
	       } else XmTextFieldSetString(SL_wx_baro[type][x],"");
               XtManageChild(SL_wx_baro[type][x]);


               if (station_data[data_ptr_i].wx_rain_on) {
                  if (!units_english_metric) {  
                     sprintf(stemp,"%0.2f",atof(station_data[data_ptr_i].wx_rain)*.254);
                     XmTextFieldSetString(SL_wx_rain_h[type][x],stemp);
		  } else XmTextFieldSetString(SL_wx_rain_h[type][x],station_data[data_ptr_i].wx_rain);
	       } else XmTextFieldSetString(SL_wx_rain_h[type][x],"");
               XtManageChild(SL_wx_rain_h[type][x]);


               if (station_data[data_ptr_i].wx_prec_00_on) {
                  if (!units_english_metric) {  
                     sprintf(stemp,"%0.2f",atof(station_data[data_ptr_i].wx_prec_00)*.254);
                     XmTextFieldSetString(SL_wx_rain_00[type][x],stemp);
		  } else XmTextFieldSetString(SL_wx_rain_00[type][x],station_data[data_ptr_i].wx_prec_00);
	       } else XmTextFieldSetString(SL_wx_rain_00[type][x],"");
               XtManageChild(SL_wx_rain_00[type][x]);

               if (station_data[data_ptr_i].wx_prec_24_on) {
                  if (!units_english_metric) {  
                     sprintf(stemp,"%0.2f",atof(station_data[data_ptr_i].wx_prec_24)*.254);
                     XmTextFieldSetString(SL_wx_rain_24[type][x],stemp);
		  } else XmTextFieldSetString(SL_wx_rain_24[type][x],station_data[data_ptr_i].wx_prec_24);
	       } else XmTextFieldSetString(SL_wx_rain_24[type][x],"");
               XtManageChild(SL_wx_rain_24[type][x]);

              break;

          default:break;
	}
     } else {

         XtVaSetValues(SL_da[type][x],
                      XmNlabelPixmap, blank_icon,
                      NULL);      

         XtManageChild(SL_da[type][x]);

          symbol(SL_da[type][x],0,'~','$',0,SL_icon[type][x],0,0,0);

          XtVaSetValues(SL_da[type][x],
                      XmNlabelPixmap, SL_icon[type][x],
                      NULL);      

          XtManageChild(SL_da[type][x]);


          sprintf(temp,"%d",(i+1));
          XmTextFieldSetString(SL_list[type][x],temp);
          XtManageChild(SL_list[type][x]);

          XmTextFieldSetString(SL_call[type][x],"");
          XtManageChild(SL_call[type][x]);

          switch (type) {
             case 3:/*local stations list */
             case 0:/*stations list */

               XmTextFieldSetString(SL_packets[type][x],"");
               XtManageChild(SL_packets[type][x]);

               XmTextFieldSetString(SL_pos_time[type][x],"");
               XtManageChild(SL_pos_time[type][x]);

               XmTextFieldSetString(SL_node_path[type][x],"");
               XtManageChild(SL_node_path[type][x]);

               XmTextFieldSetString(SL_power_gain[type][x],"");
               XtManageChild(SL_power_gain[type][x]);

               XmTextFieldSetString(SL_comments[type][x],"");
               XtManageChild(SL_comments[type][x]);

               break;

             case 1:/* mobile stations list */
               XmTextFieldSetString(SL_course[type][x],"");
               XtManageChild(SL_course[type][x]);  

               XmTextFieldSetString(SL_speed[type][x],"");
               XtManageChild(SL_speed[type][x]);  

               XmTextFieldSetString(SL_alt[type][x],"");
               XtManageChild(SL_alt[type][x]);

               XmTextFieldSetString(SL_lat[type][x],"");
               XtManageChild(SL_lat[type][x]);

               XmTextFieldSetString(SL_long[type][x],"");
               XtManageChild(SL_long[type][x]);

               XmTextFieldSetString(SL_packets[type][x],"");
               XtManageChild(SL_packets[type][x]);

               XmTextFieldSetString(SL_sats[type][x],"");
               XtManageChild(SL_sats[type][x]);

               XmTextFieldSetString(SL_my_course[type][x],"");
               XtManageChild(SL_my_course[type][x]);

               XmTextFieldSetString(SL_my_distance[type][x],"");
               XtManageChild(SL_my_distance[type][x]);
    
               break;

             case 2:/*WX stations list */

               XmTextFieldSetString(SL_wx_wind_course[type][x],"");
               XtManageChild(SL_wx_wind_course[type][x]);  

               XmTextFieldSetString(SL_wx_wind_speed[type][x],"");
               XtManageChild(SL_wx_wind_speed[type][x]);  

               XmTextFieldSetString(SL_wx_wind_gust[type][x],"");
               XtManageChild(SL_wx_wind_gust[type][x]);

               XmTextFieldSetString(SL_wx_temp[type][x],"");
               XtManageChild(SL_wx_temp[type][x]);  

               XmTextFieldSetString(SL_wx_hum[type][x],"");
               XtManageChild(SL_wx_hum[type][x]);

               XmTextFieldSetString(SL_wx_baro[type][x],"");
               XtManageChild(SL_wx_baro[type][x]);

               XmTextFieldSetString(SL_wx_rain_h[type][x],"");
               XtManageChild(SL_wx_rain_h[type][x]);  

               XmTextFieldSetString(SL_wx_rain_00[type][x],"");
               XtManageChild(SL_wx_rain_00[type][x]);  

               XmTextFieldSetString(SL_wx_rain_24[type][x],"");
               XtManageChild(SL_wx_rain_24[type][x]);  

               break;

             default:break;
	  }

     }
        
    x++;
    station_i++;
     
 }
 }
}

void update_station_scroll_list(void)
{int i;
 int now;
 int pos;
 int last_h, last_w;
 int last;

 last_h=last_w=0;

 for (i=0;i<4;i++) {
     if (station_list_dialog[i]!=NULL) {
         XtVaGetValues(station_list_dialog[i], XmNheight, &last_h, XmNwidth, &last_w, NULL);
         XtVaGetValues(SL_scroll[i], XmNmaximum,&last,XmNvalue, &pos, NULL);
         now=stations_types(i);
         if ((last!=now) || (last_h!=list_size_h[i]) || (last_w!=list_size_w[i]) || units_last!=units_english_metric || max_update>10) {
            /*printf("LAST:%d NOW:%d\n",last,now);
            printf("H:%d last:%d W:%d last %d\n",last_h,list_size_h[i],last_w,list_size_w[i]);*/
            XtVaSetValues(SL_scroll[i], XmNmaximum ,now, NULL);
            Station_List_fill(i,pos);  
            max_update=0;
	 } else max_update++;
     }
  
 }
units_last=units_english_metric;
}



void dragCallback(Widget w, XtPointer clientData, XtPointer callData)
{int i;
 XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)callData;

 i=atoi((char *)clientData);
 Station_List_fill(i,cbs->value);
}

void decrementCallback(Widget w, XtPointer clientData, XtPointer callData)
{int i;
 XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)callData;

 i=atoi((char *)clientData);
 Station_List_fill(i,cbs->value);
}

void incrementCallback(Widget w, XtPointer clientData, XtPointer callData)
{int i;
 XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)callData;

 i=atoi((char *)clientData);
 Station_List_fill(i,cbs->value);
}

void pageDecrementCallback(Widget w, XtPointer clientData, XtPointer callData)
{int i;
 XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)callData;

 i=atoi((char *)clientData);
 Station_List_fill(i,cbs->value);
}

void pageIncrementCallback(Widget w, XtPointer clientData, XtPointer callData)
{int i;
 XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)callData;

 i=atoi((char *)clientData);
 Station_List_fill(i,cbs->value);
}

void valueChangedCallback(Widget w, XtPointer clientData, XtPointer callData)
{int i;
 XmScrollBarCallbackStruct *cbs = (XmScrollBarCallbackStruct *)callData;

 i=atoi((char *)clientData);
 Station_List_fill(i,cbs->value);
}




void Station_List(Widget w, XtPointer clientData, XtPointer callData)
{
  int i;  
  Widget pane, form, win_list, form2, button_close;
  Widget numl,call,sep,sep2;
  Widget it1, it2, it3, it4, it5, it6, it7, it8, it9;
  Widget seps[40];
  Atom delw;
  int type;
  char temp[400];

  if (station_list_first) {
     station_list_icons();
     station_list_first=0;
  }

  type=atoi((char *)clientData);

  switch(type) {

   case 0:strcpy(temp,langcode("LHPUPNI000"));
     break;

   case 1:strcpy(temp,langcode("LHPUPNI001"));
     break;

   case 2:strcpy(temp,langcode("LHPUPNI002"));
     break;

   case 3:strcpy(temp,langcode("LHPUPNI003"));
     break;

   default:break;
  }

  if (!station_list_dialog[type]) {

     station_list_dialog[type]= XtVaCreatePopupShell(temp, xmDialogShellWidgetClass, hidden_shell,
					       XmNdeleteResponse, XmDESTROY,
					       XmNdefaultPosition, False,
                                               XmNminWidth, 274,
                                               XmNmaxHeight,610,
                                               XmNminHeight,95,
					       NULL);

     pane = XtVaCreateWidget("pane",xmPanedWindowWidgetClass, station_list_dialog[type],
                          XmNbackground, colors[0xff],
                          NULL); 

     form = XtVaCreateWidget(NULL,xmFormWidgetClass, pane,
                             XmNfractionBase, 5, 
                             XmNshadowType, XmSHADOW_OUT,
                             XmNshadowThickness, 1,
                             XmNbackground, colors[0xff],
                             XmNautoUnmanage, False,
                             XmNshadowThickness, 1, 
                             NULL);


     numl = XtVaCreateManagedWidget(langcode("LHPUPNI010"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 5,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2,
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_FORM,
                                 XmNleftOffset, 3,
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

     XmTextFieldSetString(numl,langcode("LHPUPNI010"));
             

     call = XtVaCreateManagedWidget(langcode("LHPUPNI011"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 12,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset, 2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, numl,
                                 XmNleftOffset, 22,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                

     XmTextFieldSetString(call,langcode("LHPUPNI011"));                                       

     switch (type) {

        case 3:/*local station list */
        case 0:/*station list */

            it1 = XtVaCreateManagedWidget(langcode("LHPUPNI012"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 5,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, call,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);  
            XmTextFieldSetString(it1,langcode("LHPUPNI012")); 

            it2 = XtVaCreateManagedWidget(langcode("LHPUPNI013"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 17,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset, 2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it1,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                  
                                     
            XmTextFieldSetString(it2,langcode("LHPUPNI013")); 

            it3 = XtVaCreateManagedWidget(langcode("LHPUPNI014"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 30,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset, 2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it2,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);            

            XmTextFieldSetString(it3,langcode("LHPUPNI014")); 

            it4 = XtVaCreateManagedWidget(langcode("LHPUPNI015"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 7,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it3,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);          
                                             
            XmTextFieldSetString(it4,langcode("LHPUPNI015"));
 
            it5 = XtVaCreateManagedWidget(langcode("LHPUPNI016"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 40,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it4,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                  

           XmTextFieldSetString(it5,langcode("LHPUPNI016")); 

           break;

        case 1:/*mobile list */

            it1 = XtVaCreateManagedWidget(langcode("LHPUPNI100"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 3,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, call,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

            XmTextFieldSetString(it1,langcode("LHPUPNI100"));
 
            it2 = XtVaCreateManagedWidget(langcode("LHPUPNI101"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 4,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it1,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

            XmTextFieldSetString(it2,langcode("LHPUPNI101"));
  
            it3 = XtVaCreateManagedWidget(langcode("LHPUPNI102"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 8,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it2,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);            

            XmTextFieldSetString(it3,langcode("LHPUPNI102"));

            it4 = XtVaCreateManagedWidget(langcode("LHPUPNI103"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 10,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it3,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                      
                                 
            XmTextFieldSetString(it4,langcode("LHPUPNI103")); 

            it5 = XtVaCreateManagedWidget(langcode("LHPUPNI104"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 11,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it4,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                               

            XmTextFieldSetString(it5,langcode("LHPUPNI104"));
 
            it6 = XtVaCreateManagedWidget(langcode("LHPUPNI105"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 5,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it5,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);          

            XmTextFieldSetString(it6,langcode("LHPUPNI105"));

            it7 = XtVaCreateManagedWidget(langcode("LHPUPNI106"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 3,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it6,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                                                                    

            XmTextFieldSetString(it7,langcode("LHPUPNI106"));

            it8 = XtVaCreateManagedWidget(langcode("LHPUPNI107"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 5,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it7,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                      
                                                                              
            XmTextFieldSetString(it8,langcode("LHPUPNI107"));

            it9 = XtVaCreateManagedWidget(langcode("LHPUPNI108"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 6,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it8,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                     
                                                                               
           XmTextFieldSetString(it9,langcode("LHPUPNI108"));

           break;

        case 2:/*wx list */

            it1 = XtVaCreateManagedWidget(langcode("LHPUPNI200"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 3,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, call,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

            XmTextFieldSetString(it1,langcode("LHPUPNI200"));

            it2 = XtVaCreateManagedWidget(langcode("LHPUPNI201"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 3,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it1,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

            XmTextFieldSetString(it2,langcode("LHPUPNI201"));
 
            it3 = XtVaCreateManagedWidget(langcode("LHPUPNI202"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 3,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it2,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                  

            XmTextFieldSetString(it3,langcode("LHPUPNI202"));                                     

            it4 = XtVaCreateManagedWidget(langcode("LHPUPNI203"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 4,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it3,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

            XmTextFieldSetString(it4,langcode("LHPUPNI203"));

            it5 = XtVaCreateManagedWidget(langcode("LHPUPNI204"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 3,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it4,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

            XmTextFieldSetString(it5,langcode("LHPUPNI204"));

            it6 = XtVaCreateManagedWidget(langcode("LHPUPNI205"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 6,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it5,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

            XmTextFieldSetString(it6,langcode("LHPUPNI205"));

            it7 = XtVaCreateManagedWidget(langcode("LHPUPNI206"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 5,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it6,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

            XmTextFieldSetString(it7,langcode("LHPUPNI206"));

            it8 = XtVaCreateManagedWidget(langcode("LHPUPNI207"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 5,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it7,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                 

            XmTextFieldSetString(it8,langcode("LHPUPNI207"));

            it9 = XtVaCreateManagedWidget(langcode("LHPUPNI208"), xmTextFieldWidgetClass, form,
                                 XmNeditable,   False,
                                 XmNcursorPositionVisible, False,
                                 XmNsensitive, STIPPLE,
                                 XmNshadowThickness, 0,
                                 XmNcolumns, 5,                                       
                                 XmNtopAttachment, XmATTACH_FORM,
                                 XmNtopOffset,2, 
                                 XmNbottomAttachment, XmATTACH_NONE,
                                 XmNleftAttachment, XmATTACH_WIDGET,
                                 XmNleftWidget, it8,
                                 XmNleftOffset, 1,  
                                 XmNrightAttachment, XmATTACH_NONE,
                                 XmNbackground, colors[0xff], 
                                 NULL);                                                       

           XmTextFieldSetString(it9,langcode("LHPUPNI208"));

           break;

        default:break;
     }

     sep = XtVaCreateManagedWidget("sep", xmSeparatorGadgetClass,form,
                                      XmNorientation, XmHORIZONTAL,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, numl,
                                      XmNtopOffset,2,  
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNrightAttachment, XmATTACH_FORM,
                                      NULL); 


    SL_scroll[type] = XtVaCreateManagedWidget("scroll", xmScrollBarWidgetClass,form,
                                      XmNorientation, XmVERTICAL,
                                      XmNmaximum,  stations_types(type),
                                      XmNsliderSize, 10,
                                      XmNprocessingDirection, XmMAX_ON_BOTTOM,
                                      XmNpageIncrement,18,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, sep,
                                      XmNtopOffset,0,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNbottomOffset, 42,
                                      XmNleftAttachment, XmATTACH_NONE,
                                      XmNrightAttachment, XmATTACH_FORM,
                                      XmNbackground, colors[0xff],    
                                      NULL); 



     win_list =  XtVaCreateWidget("list",xmFormWidgetClass, form,
                                  XmNtopAttachment, XmATTACH_WIDGET,
                                  XmNtopWidget,sep,
                                  XmNtopOffset, 2,
                                  XmNbottomAttachment, XmATTACH_FORM,
                                  XmNbottomOffset,42, 
                                  XmNleftAttachment, XmATTACH_FORM,
                                  XmNleftOffset, 2,
                                  XmNrightAttachment, XmATTACH_WIDGET,
                                  XmNrightWidget,SL_scroll[type],
                                  XmNbackground, colors[0xff], 
                                  NULL);




     for (i=0; i<18;i++) {


         if (i!=0) {
            seps[i] = XtVaCreateManagedWidget("seps", xmSeparatorGadgetClass, win_list,
                                      XmNorientation, XmHORIZONTAL,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNrightAttachment, XmATTACH_FORM,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,SL_list[type][i-1],
                                      XmNbackground, colors[0xff], 
                                      NULL); 
            
            SL_list[type][i]= XtVaCreateManagedWidget("line data", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE,
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 5,
                                      XmNleftAttachment,XmATTACH_FORM,
                                      XmNleftOffset, 2,
                                      XmNtopAttachment,XmATTACH_WIDGET,
                                      XmNtopWidget, seps[i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      XmNbackground, colors[0xff], 
                                      NULL);

	 } else {

           SL_list[type][i]= XtVaCreateManagedWidget("line data", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE,
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 5,
                                      XmNleftAttachment,XmATTACH_FORM,
                                      XmNleftOffset, 2,
                                      XmNtopAttachment,XmATTACH_FORM,
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      XmNbackground, colors[0xff], 
                                      NULL);
	 }

          SL_da[type][i] = XtVaCreateManagedWidget("icon", xmLabelWidgetClass, win_list,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNtopOffset, 2,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget,SL_list[type][i],
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNlabelType, XmPIXMAP,
                                      XmNlabelPixmap,SL_icon[type][i],
                                      XmNbackground, colors[0xff], 
                                      NULL);                                                       

          SL_call[type][i]= XtVaCreateManagedWidget("call data", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, True, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 12,
                                      XmNbackground, colors[0x0f],
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_da[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

          switch (type) {

            case 3:/*local station list */
            case 0:/*station list */

               SL_packets[type][i] = XtVaCreateManagedWidget("SL packets", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 5,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_call[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_pos_time[type][i] = XtVaCreateManagedWidget("SL pos_time", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 17,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_packets[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_node_path[type][i] = XtVaCreateManagedWidget("SL node_path", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 30,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_pos_time[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_power_gain[type][i] = XtVaCreateManagedWidget("SL packets", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 7,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_node_path[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_comments[type][i] = XtVaCreateManagedWidget("SL comments", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 40,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_power_gain[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               break;
 
            case 1:/*mobile list */
               SL_course[type][i] = XtVaCreateManagedWidget("SL course", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 3,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_call[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_speed[type][i] = XtVaCreateManagedWidget("SL speed", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 4,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_course[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

              SL_alt[type][i] = XtVaCreateManagedWidget("SL alt", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 8,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_speed[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_lat[type][i] = XtVaCreateManagedWidget("SL lat", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 10,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_alt[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_long[type][i] = XtVaCreateManagedWidget("SL long", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 11,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_lat[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_packets[type][i] = XtVaCreateManagedWidget("SL packets", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 5,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_long[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_sats[type][i] = XtVaCreateManagedWidget("SL sats", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 3,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_packets[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_my_course[type][i] = XtVaCreateManagedWidget("SL my course", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 5,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_sats[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_my_distance[type][i] = XtVaCreateManagedWidget("SL my distance", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 6,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_my_course[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

                break;

            case 2:/*wx list */

               SL_wx_wind_course[type][i] = XtVaCreateManagedWidget("SL wind course", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 3,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_call[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_wx_wind_speed[type][i] = XtVaCreateManagedWidget("SL wind speed", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 3,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_wx_wind_course[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);


               SL_wx_wind_gust[type][i] = XtVaCreateManagedWidget("SL wind gust", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 3,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_wx_wind_speed[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_wx_temp[type][i] = XtVaCreateManagedWidget("SL temp", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 4,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_wx_wind_gust[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_wx_hum[type][i] = XtVaCreateManagedWidget("SL humidity", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 3,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_wx_temp[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_wx_baro[type][i] = XtVaCreateManagedWidget("SL wx baro", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 6,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_wx_hum[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_wx_rain_h[type][i] = XtVaCreateManagedWidget("SL rain hour", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 5,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_wx_baro[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_wx_rain_00[type][i] = XtVaCreateManagedWidget("SL rain since mid", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 5,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_wx_rain_h[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               SL_wx_rain_24[type][i] = XtVaCreateManagedWidget("SL rain last 24", xmTextFieldWidgetClass, win_list,
                                      XmNeditable,   False,
                                      XmNcursorPositionVisible, False,
                                      XmNsensitive, STIPPLE, 
                                      XmNshadowThickness, 0,
                                      XmNcolumns, 5,
                                      XmNbackground, colors[0x0f],
                                      XmNalignment, XmALIGNMENT_END,
                                      XmNleftAttachment,XmATTACH_WIDGET,
                                      XmNleftWidget, SL_wx_rain_00[type][i],
                                      XmNleftOffset, 1,
                                      XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET,
                                      XmNtopWidget, SL_list[type][i],
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

               break;

            default:break;

	  }

     }


   form2 = XtVaCreateWidget(NULL,xmFormWidgetClass, form,
                                 XmNfractionBase, 5, 
                                 XmNtopAttachment, XmATTACH_WIDGET,
                                 XmNtopWidget, SL_scroll[type],
                                 XmNbottomAttachment, XmATTACH_FORM,  
                                 XmNrightAttachment, XmATTACH_FORM,
                                 XmNleftAttachment, XmATTACH_FORM,
                                 XmNbackground, colors[0xff],  
                                 NULL);

   sep2 = XtVaCreateManagedWidget("sep2", xmSeparatorGadgetClass,form2,
                                      XmNorientation, XmHORIZONTAL,
                                      XmNtopAttachment, XmATTACH_FORM,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNrightAttachment, XmATTACH_FORM,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNbackground, colors[0xff],  
                                      NULL); 

   button_close = XtVaCreateManagedWidget(langcode("UNIOP00003"),xmPushButtonGadgetClass,form2,
                                                XmNtopAttachment, XmATTACH_WIDGET,
                                                XmNtopWidget, sep2,
                                                XmNtopOffset, 4,
                                                XmNbottomAttachment, XmATTACH_FORM,
                                                XmNbottomOffset, 2,
                                                XmNleftAttachment, XmATTACH_POSITION,
                                                XmNleftPosition, 2,
                                                XmNrightAttachment, XmATTACH_POSITION,
                                                XmNrightPosition, 3,
                                                XmNbackground, colors[0xff],                   
						NULL);

 

  pos_dialog(station_list_dialog[type]);

  delw = XmInternAtom(XtDisplay(station_list_dialog[type]), "WM_DELETE_WINDOW", False);

  /* call backs */
  switch(type) {

   case 0:
    XtAddCallback(SL_scroll[type], XmNdecrementCallback, decrementCallback,"0");
    XtAddCallback(SL_scroll[type], XmNdragCallback, dragCallback, "0");
    XtAddCallback(SL_scroll[type], XmNincrementCallback, incrementCallback,"0");
    XtAddCallback(SL_scroll[type], XmNpageDecrementCallback, pageDecrementCallback,"0");
    XtAddCallback(SL_scroll[type], XmNpageIncrementCallback, pageIncrementCallback,"0");
    XtAddCallback(SL_scroll[type], XmNvalueChangedCallback, valueChangedCallback,"0");

    XtAddCallback(button_close, XmNactivateCallback, station_list_destroy_shell, "0");
    XmAddWMProtocolCallback(station_list_dialog[type], delw, station_list_destroy_shell,"0");
    break;

   case 1:
    XtAddCallback(SL_scroll[type], XmNdecrementCallback, decrementCallback,"1");
    XtAddCallback(SL_scroll[type], XmNdragCallback, dragCallback, "1");
    XtAddCallback(SL_scroll[type], XmNincrementCallback, incrementCallback,"1");
    XtAddCallback(SL_scroll[type], XmNpageDecrementCallback, pageDecrementCallback,"1");
    XtAddCallback(SL_scroll[type], XmNpageIncrementCallback, pageIncrementCallback,"1");
    XtAddCallback(SL_scroll[type], XmNvalueChangedCallback, valueChangedCallback,"1");

    XtAddCallback(button_close, XmNactivateCallback, station_list_destroy_shell, "1");
    XmAddWMProtocolCallback(station_list_dialog[type], delw, station_list_destroy_shell,"1");
    break;

   case 2:
    XtAddCallback(SL_scroll[type], XmNdecrementCallback, decrementCallback,"2");
    XtAddCallback(SL_scroll[type], XmNdragCallback, dragCallback, "2");
    XtAddCallback(SL_scroll[type], XmNincrementCallback, incrementCallback,"2");
    XtAddCallback(SL_scroll[type], XmNpageDecrementCallback, pageDecrementCallback,"2");
    XtAddCallback(SL_scroll[type], XmNpageIncrementCallback, pageIncrementCallback,"2");
    XtAddCallback(SL_scroll[type], XmNvalueChangedCallback, valueChangedCallback,"2");
  
    XtAddCallback(button_close, XmNactivateCallback, station_list_destroy_shell, "2");
    XmAddWMProtocolCallback(station_list_dialog[type], delw, station_list_destroy_shell,"2");
    break;

   case 3:
    XtAddCallback(SL_scroll[type], XmNdecrementCallback, decrementCallback,"3");
    XtAddCallback(SL_scroll[type], XmNdragCallback, dragCallback, "3");
    XtAddCallback(SL_scroll[type], XmNincrementCallback, incrementCallback,"3");
    XtAddCallback(SL_scroll[type], XmNpageDecrementCallback, pageDecrementCallback,"3");
    XtAddCallback(SL_scroll[type], XmNpageIncrementCallback, pageIncrementCallback,"3");
    XtAddCallback(SL_scroll[type], XmNvalueChangedCallback, valueChangedCallback,"3");

    XtAddCallback(button_close, XmNactivateCallback, station_list_destroy_shell, "3");
    XmAddWMProtocolCallback(station_list_dialog[type], delw, station_list_destroy_shell,"3");

    break;

   default:break;
  }

  XtManageChild(form);
  XtManageChild(win_list);
  XtManageChild(form2);
  XtManageChild(pane);

  XtPopup(station_list_dialog[type], XtGrabNone);

  /* set last size if there was one */
  if (list_size_w[type] != -1 && list_size_h[type] != -1) {
      XtVaSetValues(station_list_dialog[type], XmNwidth, list_size_w[type], XmNheight, list_size_h[type], NULL);
  }

  Station_List_fill(type,0);

  } else {
     XRaiseWindow(XtDisplay(station_list_dialog[type]), XtWindow(station_list_dialog[type]));
  }
} 

