/*
XASTIR, Amateur Station Tracking and Information Reporting
Copyright (C) 1999  Frank Giannandrea 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

More information on the program can be found at:
Web,
 http://www.eazy.net/users/fgiannan/xasitr/
Email,
 fgiannan@eazy.net
*/

#include <stdlib.h>


#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/List.h>
#include <Xm/Label.h>
#include <Xm/PanedW.h>
#include <Xm/Protocols.h>
#include <Xm/PushBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>

#include "main.h"
#include "xastir.h"

extern Widget appshell;
extern Widget GetTopShell(Widget w);
extern void pos_dialog(Widget w);
extern void on_off_switch(int switchpos, Widget first, Widget second);

/* from lang.c */
extern char *langcode(char *code);
extern char langcode_hotkey(char *code);


Widget auto_msg_on, auto_msg_off;
Widget auto_msg_dialog = (Widget)NULL;
Widget auto_msg_set_data = (Widget)NULL;


/**** Send Message ******/

void Send_message_destroy_shell(Widget widget, XtPointer clientData, XtPointer callData)
{int i; 

 i=atoi((char *)clientData);
 XtPopdown(mw[i].send_message_dialog);
 XtDestroyWidget(mw[i].send_message_dialog);
 mw[i].send_message_dialog = (Widget)NULL;
 mw[i].send_message_call_data = (Widget)NULL;

}

void Check_new_call_messages(Widget w, XtPointer clientData, XtPointer callData)
{int i,pos;
 i=atoi((char *)clientData);
   /* clear window*/
   pos=0;
   XtVaSetValues(mw[i].send_message_text,XmNcursorPosition,&pos,NULL);
   XmTextSetString(mw[i].send_message_text,"");
   XmTextInsert(mw[i].send_message_text,pos,"");
   XtVaSetValues(mw[i].send_message_text,XmNcursorPosition,pos,NULL);
   XmTextShowPosition(mw[i].send_message_text,pos);
 update_messages();
}

void Clear_messages(Widget w, XtPointer clientData, XtPointer callData)
{
clear_outgoing_messages();
}

void Send_message_now(Widget w, XtPointer clientData, XtPointer callData)
{char temp1[MAX_CALL+1];
 char temp2[302];
 int i;

i=atoi((char *)clientData);

/* find station and go there */
strcpy(temp1,XmTextFieldGetString(mw[i].send_message_call_data));
remove_trailing_spaces(temp1);  
strcpy(temp2,XmTextFieldGetString(mw[i].send_message_message_data));
to_upper(temp1);
if(debug_level & 2)
  {printf("Send message to <%s> from <%s> :%s\n",temp1,mw[i].to_call_sign,temp2);}
/* if your sending a message you must be at the keyboard */
auto_reply=0;
on_off_switch(auto_reply,auto_msg_on,auto_msg_off);
XmTextFieldSetString(text,langcode("BBARSTA011"));
output_message(mw[i].to_call_sign,temp1,temp2);
XmTextFieldSetString(mw[i].send_message_message_data,"");
if(mw[i].message_group!=1)
  {XtSetSensitive(mw[i].button_ok,False);}
}


void Clear_message_from(Widget w, XtPointer clientData, XtPointer callData)
{char temp1[MAX_CALL+1];
 int i;
/* int pos;*/

i=atoi((char *)clientData);
/* find station and go there */
strcpy(temp1,XmTextFieldGetString(mw[i].send_message_call_data));
remove_trailing_spaces(temp1);  
to_upper(temp1);
/*printf("Clear message from <%s> to <%s>\n",temp1,my_callsign);*/
   mdelete_messages_from(temp1);
   new_message_data=1;
}

void Clear_message_to(Widget w, XtPointer clientData, XtPointer callData)
{char temp1[MAX_CALL+1];
 int i;


i=atoi((char *)clientData);
/* find station and go there */
strcpy(temp1,XmTextFieldGetString(mw[i].send_message_call_data));
remove_trailing_spaces(temp1);  
to_upper(temp1);
/*printf("Clear message to <%s>\n",temp1);*/
   mdelete_messages_to(temp1);
   new_message_data=1;
}


void Send_message_call(Widget w, XtPointer clientData, XtPointer callData)
{char call[20];
if(clientData !=NULL)
  {strcpy(call,(char *)clientData);
   Send_message(hidden_shell,call,NULL);
  }           
}


void Send_message(Widget w, XtPointer clientData, XtPointer callData)
{Arg args[20];
 char temp[60];
 int n;
 int j,i;
 char group[MAX_CALLSIGN+1];
 int groupon;
 int box_len;
 Atom delw;

 groupon=0;
 box_len=85;
 i=0;
 for(j=0; j<MAX_MESSAGE_WINDOWS; j++)
    {if(!mw[j].send_message_dialog)
       {i=j;
        j=MAX_MESSAGE_WINDOWS+1;
       }
    }

 if(!mw[i].send_message_dialog)   
   {if(clientData !=NULL)
      {strcpy(group,(char *)clientData);
       group[1]=0;
       if(group[0]=='*')
         {strcpy(mw[i].to_call_sign,"***");
          (char *)clientData=NULL;
          groupon=1;
          box_len=100;
	 }
         else
         {strcpy(mw[i].to_call_sign,my_callsign);}
      }
      else
      {strcpy(mw[i].to_call_sign,my_callsign);}

    if(groupon==0)
      {sprintf(temp,langcode("WPUPMSB001"),(i+1));
       mw[i].message_group=0; 
      }
      else
      {sprintf(temp,langcode("WPUPMSB002"),(i+1));
       mw[i].message_group=1; 
      }
    mw[i].send_message_dialog = XtVaCreatePopupShell(temp,xmDialogShellWidgetClass,hidden_shell,
                                  XmNdeleteResponse,XmDESTROY,
                                  XmNdefaultPosition, False,
                                  XmNtitleString,"Send Message",
                                  NULL);

    mw[i].pane = XtVaCreateWidget("pane",xmPanedWindowWidgetClass, mw[i].send_message_dialog,
                          XmNbackground, colors[0xff],
                          NULL);

    mw[i].form =  XtVaCreateWidget("form2",xmFormWidgetClass,mw[i].pane,
                            XmNfractionBase, 5, 
                            XmNautoUnmanage, False,
                            XmNbackground, colors[0xff],
                            XmNshadowThickness, 1,
                            NULL);

    n=0;
    XtSetArg(args[n], XmNrows, 10); n++;
    XtSetArg(args[n], XmNmaxHeight, 170); n++;
    XtSetArg(args[n], XmNcolumns, box_len); n++;
    XtSetArg(args[n], XmNeditable, False); n++;
    XtSetArg(args[n], XmNtraversalOn, False); n++;
    XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
    XtSetArg(args[n], XmNwordWrap, True); n++; 
    XtSetArg(args[n], XmNshadowThickness, 3); n++;
    XtSetArg(args[n], XmNbackground, colors[0xff]); n++;
    XtSetArg(args[n], XmNscrollHorizontal, False); n++;
    XtSetArg(args[n], XmNcursorPositionVisible, False); n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNtopOffset, 5); n++;
    XtSetArg(args[n], XmNbottomAttachment,XmATTACH_NONE); n++;                                
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNleftOffset, 5); n++;
    XtSetArg(args[n], XmNrightAttachment,XmATTACH_FORM); n++;
    XtSetArg(args[n], XmNrightOffset,5); n++;

    mw[i].send_message_text = XmCreateScrolledText(mw[i].form,"smt",args,n); 

    if(groupon==0)
      {mw[i].call = XtVaCreateManagedWidget(langcode("WPUPMSB003"),xmLabelWidgetClass, mw[i].form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(mw[i].send_message_text),
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      NULL);

       mw[i].send_message_call_data = XtVaCreateManagedWidget("smcd", xmTextFieldWidgetClass, mw[i].form,
                                      XmNeditable,   True,
                                      XmNcursorPositionVisible, True,
                                      XmNsensitive, True,
		                      XmNshadowThickness,	1,
                                      XmNcolumns, 15,
                                      XmNwidth, ((15*7)+2),   
                                      XmNmaxLength, 15,
                                      XmNbackground, colors[0x0f],
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(mw[i].send_message_text),
                                      XmNtopOffset, 5,    
                                      XmNbottomAttachment,XmATTACH_NONE,                                
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget, mw[i].call,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      NULL);

      }
      else
      {mw[i].call = XtVaCreateManagedWidget(langcode("WPUPMSB004"),xmLabelWidgetClass, mw[i].form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(mw[i].send_message_text),
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      NULL);

       mw[i].send_message_call_data = XtVaCreateManagedWidget("smcd", xmTextFieldWidgetClass, mw[i].form,
                                      XmNeditable,   True,
                                      XmNcursorPositionVisible, True,
                                      XmNsensitive, True,
	                              XmNshadowThickness,	1,
                                      XmNcolumns, 15,
                                      XmNwidth, ((15*7)+2),  
                                      XmNmaxLength, 15,
                                      XmNbackground, colors[0x0f],
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(mw[i].send_message_text),
                                      XmNtopOffset, 5,    
                                      XmNbottomAttachment,XmATTACH_NONE,                                
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget, mw[i].call,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);
      }



     if(groupon==0)
       {sprintf(temp,langcode("WPUPMSB005"));}
       else
       {sprintf(temp,langcode("WPUPMSB006"));}

     mw[i].button_submit_call = XtVaCreateManagedWidget(temp,xmPushButtonGadgetClass, mw[i].form,
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget, mw[i].send_message_call_data, 
                                      XmNleftOffset, 20,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(mw[i].send_message_text),
                                      XmNtopOffset, 5,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);

     mw[i].button_clear_msg = XtVaCreateManagedWidget(langcode("WPUPMSB007"),xmPushButtonGadgetClass, mw[i].form,
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget, mw[i].button_submit_call, 
                                      XmNleftOffset, 10,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget,XtParent(mw[i].send_message_text),
                                      XmNtopOffset, 5,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);


    mw[i].message = XtVaCreateManagedWidget(langcode("WPUPMSB008"),xmLabelWidgetClass, mw[i].form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, mw[i].call,
                                      XmNtopOffset, 20,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      NULL);


    mw[i].send_message_message_data = XtVaCreateManagedWidget("smmd", xmTextFieldWidgetClass, mw[i].form,
                                      XmNeditable,   True,
                                      XmNcursorPositionVisible, True,
                                      XmNsensitive, True,
				      XmNshadowThickness,	1,
                                      XmNcolumns, 64,
                                      XmNwidth, ((64*7)+2),
                                      XmNmaxLength, 255,
                                      XmNbackground, colors[0x0f],
                                      XmNtopAttachment,XmATTACH_WIDGET,
                                      XmNtopWidget, mw[i].call,
                                      XmNtopOffset, 15,
                                      XmNbottomAttachment,XmATTACH_NONE,                                
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget, mw[i].message,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);


    mw[i].button_ok = XtVaCreateManagedWidget(langcode("WPUPMSB009"),xmPushButtonGadgetClass, mw[i].form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, mw[i].send_message_message_data, 
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNbottomOffset, 5,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 1,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 2,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);

    mw[i].button_cancel = XtVaCreateManagedWidget(langcode("UNIOP00003"),xmPushButtonGadgetClass, mw[i].form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, mw[i].send_message_message_data,  
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNbottomOffset, 5,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 3,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 4,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);

   sprintf(mw[i].win,"%d",i);

   XtAddCallback(mw[i].button_ok, XmNactivateCallback, Send_message_now, (XtPointer)mw[i].win);
   XtAddCallback(mw[i].button_cancel, XmNactivateCallback, Send_message_destroy_shell,(XtPointer)mw[i].win);
   if(groupon==0)
     {XtAddCallback(mw[i].button_clear_msg, XmNactivateCallback, Clear_message_from, (XtPointer)mw[i].win);}
     else
     {XtAddCallback(mw[i].button_clear_msg, XmNactivateCallback, Clear_message_to, (XtPointer)mw[i].win);}
   XtAddCallback(mw[i].button_submit_call, XmNactivateCallback,  Check_new_call_messages, (XtPointer)mw[i].win);

   if((char *)clientData!=NULL)
     {XmTextFieldSetString(mw[i].send_message_call_data,(char *)clientData);}

   pos_dialog(mw[i].send_message_dialog);

   delw = XmInternAtom(XtDisplay(mw[i].send_message_dialog),"WM_DELETE_WINDOW", False);
   XmAddWMProtocolCallback(mw[i].send_message_dialog, delw, Send_message_destroy_shell, (XtPointer)mw[i].win);

   XtManageChild(mw[i].form);  
   XtManageChild(mw[i].send_message_text);  
   XtVaSetValues(mw[i].send_message_text, XmNbackground, colors[0x0f], NULL);
   XtManageChild(mw[i].pane);  

   XtPopup(mw[i].send_message_dialog,XtGrabNone);
   fix_dialog_size(mw[i].send_message_dialog);
   }
}


/************************* Auto msg **************************************/
/*************************************************************************/
void Auto_msg_on(Widget w, XtPointer clientData, XtPointer calldata)
{
auto_reply=1;              /* toggle auto message responder */   
on_off_switch(auto_reply,auto_msg_on,auto_msg_off);
}

void Auto_msg_off(Widget w, XtPointer clientData, XtPointer calldata)
{
auto_reply=0;              /* toggle auto message responder */    
on_off_switch(auto_reply,auto_msg_on,auto_msg_off);
}

void Auto_msg_destroy_shell(Widget widget, XtPointer clientData, XtPointer callData)
{ 
 Widget shell = (Widget) clientData;
 XtPopdown(shell);
 XtDestroyWidget(shell);
 auto_msg_dialog = (Widget)NULL;
}

void Auto_msg_set_now(Widget w, XtPointer clientData, XtPointer callData)
{char temp[110];

strncpy(temp,XmTextFieldGetString(auto_msg_set_data),100);
temp[99]=0;
remove_trailing_spaces(temp);
strcpy(auto_reply_message,temp);
Auto_msg_destroy_shell(w, clientData, callData);
}

void Auto_msg_set(Widget w, XtPointer clientData, XtPointer callData)
{static Widget  pane, form, button_ok, button_cancel, reply;
 Atom delw;


 if(!auto_msg_dialog)   
   {auto_msg_dialog = XtVaCreatePopupShell(langcode("WPUPARM001"),xmDialogShellWidgetClass,hidden_shell,
                                  XmNdeleteResponse,XmDESTROY,
                                  XmNdefaultPosition, False,
                                  NULL);

    pane = XtVaCreateWidget("pane",xmPanedWindowWidgetClass, auto_msg_dialog,
                          XmNbackground, colors[0xff],
                          NULL);

    form =  XtVaCreateWidget("form2",xmFormWidgetClass, pane,
                            XmNfractionBase, 5, 
                            XmNbackground, colors[0xff],
                            XmNautoUnmanage, False,
                            XmNshadowThickness, 1,
                            NULL);

    reply = XtVaCreateManagedWidget(langcode("WPUPARM002"),xmLabelWidgetClass, form,
                                      XmNtopAttachment, XmATTACH_FORM,
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNleftOffset, 5,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      NULL);


    auto_msg_set_data = XtVaCreateManagedWidget("station locate data", xmTextFieldWidgetClass, form,
                                      XmNeditable,   True,
                                      XmNcursorPositionVisible, True,
                                      XmNsensitive, True,
				      XmNshadowThickness,	1,
                                      XmNcolumns, 40,
                                      XmNwidth, ((40*7)+2),
                                      XmNmaxLength, 100,
                                      XmNbackground, colors[0x0f],
                                      XmNtopAttachment,XmATTACH_FORM,
                                      XmNtopOffset, 5,
                                      XmNbottomAttachment,XmATTACH_NONE,                                
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget, reply,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment,XmATTACH_FORM,
                                      XmNrightOffset, 5,
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);

    button_ok = XtVaCreateManagedWidget(langcode("UNIOP00001"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, auto_msg_set_data, 
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNbottomOffset, 5,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 1,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 2,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);

    button_cancel = XtVaCreateManagedWidget(langcode("UNIOP00002"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, auto_msg_set_data, 
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNbottomOffset, 5,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 3,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 4,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);

   XtAddCallback(button_ok, XmNactivateCallback, Auto_msg_set_now, auto_msg_dialog);
   XtAddCallback(button_cancel, XmNactivateCallback, Auto_msg_destroy_shell, auto_msg_dialog);

   pos_dialog(auto_msg_dialog);

   delw = XmInternAtom(XtDisplay(auto_msg_dialog),"WM_DELETE_WINDOW", False);
   XmAddWMProtocolCallback(auto_msg_dialog, delw, Auto_msg_destroy_shell, (XtPointer)auto_msg_dialog);
   XmTextFieldSetString(auto_msg_set_data,auto_reply_message);

   XtManageChild(form);  
   XtManageChild(pane);  

   XtPopup(auto_msg_dialog,XtGrabNone);
   fix_dialog_size(auto_msg_dialog);
   } else {
     XRaiseWindow(XtDisplay(auto_msg_dialog), XtWindow(auto_msg_dialog));
   } 
}
